/*------------------------------------------------------------------------
Apo to Biblio:
I.Vlahavas, P.Kefalas, N.Basileiadis, F.Kokkoras, I.Sakellariou
Texnhth Nohmosunh (B' Ekdosh), Ekdoseis Gartaganh, Thessaloniki, 2005
http://aibook.csd.auth.gr
------------------------------------------------------------------------*/

/*------------------------------------------------------------
  MAZE PROBLEM DEFINITION
-------------------------------------------------------------*/

initial_state((1,3)).

goal((10,10)).

operator((X,Y),(NX,Y)):- NX is X+1, NX=<10, not(obstacle((NX,Y))).
operator((X,Y),(NX,Y)):- NX is X-1, NX>=1, not(obstacle((NX,Y))).
operator((X,Y),(X,NY)):- NY is Y+1, NY =<10, not(obstacle((X,NY))).
operator((X,Y),(X,NY)):- NY is Y-1, NY >=1, not(obstacle((X,NY))).

obstacle((X,Y)):- X>=2, X=<4, Y>=2, Y=<4.
obstacle((X,Y)):- X>=6, X=<9, Y>=6, Y=<9.
obstacle((5,10)).
obstacle((5,9)).
obstacle((5,8)).

h((X,Y),(Gx,Gy),V):-
	V is abs(X-Gx) + abs(Y-Gy).

